package com.example.testscan550;

import android.hardware.barcode.Scanner;
import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.app.Activity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;

public class ScanMainActivity extends Activity {
	private Handler mHandler = new MainHandler();
	Button m_btnClear,m_btnScan;
	EditText m_edit;
	CheckBox m_chbox;
	
	/** ԳǲAudioTrackһ̶ƵʵʾģԲϵͳ߲һƵ*/
	private final int duration = 1; // seconds
	private final int sampleRate = 2000;         
	private final int numSamples = duration * sampleRate;
	private final double sample[] = new double[numSamples];
	private final double freqOfTone = 1600; // hz    
  
	private final byte generatedSnd[] = new byte[2 * numSamples];
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_scan_main);
        m_btnClear=(Button)findViewById(R.id.buttonClear);  
        m_btnScan=(Button)findViewById(R.id.buttonScan);
        m_edit=(EditText)findViewById(R.id.editText1);         
        m_chbox=(CheckBox)findViewById(R.id.checkBox1);      
                
        m_btnScan.setOnClickListener(new OnClickListener()
        {
        	public void onClick(View v) {   
        		Scanner.Read();
        		//String str=Scanner.ReadSCAAuto();
			}                                        
        }                                    
        );            
 
        m_btnClear.setOnClickListener(new OnClickListener()
        {
        	public void onClick(View v) {   
        		m_edit.setText("");        
			}                                           
        }                  
        );  
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.scan_main, menu);
		return true;
	}
    private class MainHandler extends Handler {
    	@Override          
    	public void handleMessage(Message msg) {
    	switch (msg.what) {   
    
    	case Scanner.BARCODE_READ: {
    		//ʾ
    		m_edit.setText(m_edit.getText()+"\n"+(String)msg.obj);
    		//Ƶ༭һ
    		m_edit.setSelection(m_edit.getText().length());
    		//ûѡģʽ
    		if(!m_chbox.isChecked())
    		play();
    		break;
    	}
    	case Scanner.BARCODE_NOREAD:{   

    		break;
    	}
 
    	default:
    	break;
    	}  
    	}
    }; 
    /**
     * 
     */
	protected void onStart() {    
		// TODO Auto-generated method stub   
		//ֵhandle
		Scanner.m_handler=mHandler;  
		//ʼɨͷ
		Scanner.InitSCA();  
		super.onStart();   
	}
    public boolean onKeyDown(int keyCode, KeyEvent event)
    {
    	
    	if(event.getRepeatCount()==0){
    		if(keyCode==4)
    		{  
    			finish(); 
    		}     
    		else if((keyCode==92))  
    		{
    			//ɨ迪ʼ  
    			Scanner.Read();     
        
    		}      
		}          
    	
		return true;       
    }
    void genTone(){
    	// fill out the array
    	for (int i = 0; i < numSamples; ++i) {
    	sample[i] = Math.sin(2 * Math.PI * i / (sampleRate/freqOfTone));
    	}

    	// convert to 16 bit pcm sound array
    	// assumes the sample buffer is normalised.   
    	int idx = 0;
    	for (double dVal : sample) {
    	short val = (short) (dVal * 32767);
    	generatedSnd[idx++] = (byte) (val & 0x00ff);
    	generatedSnd[idx++] = (byte) ((val & 0xff00) >>> 8);
    	}
 
    	}

    void playSound(){
    	
    	AudioTrack audioTrack = new AudioTrack(AudioManager.STREAM_MUSIC,
    			8000, AudioFormat.CHANNEL_CONFIGURATION_MONO,
    			AudioFormat.ENCODING_PCM_16BIT, numSamples,
    			AudioTrack.MODE_STATIC);
    			audioTrack.write(generatedSnd, 0, numSamples);
    			audioTrack.play();
    			try {
					Thread.sleep(30);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
    			audioTrack.release();   

    	}
    void play()
    {
 			Thread thread = new Thread(new Runnable() {
		   public void run() {
		     genTone();
		     playSound();   

		   }  
		 });   
		 thread.start();
    }      

}
