package android.hardware.barcode;

import java.io.IOException;

import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.widget.Toast;

public class Scanner {
	static public final int BARCODE_READ = 10;
	static public final int BARCODE_NOREAD = 12;
	static Boolean m_bASYC = false;
	static int m_nCommand = 0;
	static public Handler m_handler = null;

	/**
	 * ͬɨһά/ά룬ɨ費ȴһʱ䣬Ħɨͷȴ3룬
	 * зɨͷȴ10룬ԶʶзɨͷĦɨͷ
	 * 
	 * @return ɨ赽룬ûɨΪַ
	 */
	static public native String ReadSCAAuto();

	/**
	 * ͬɨһά/ά룬ɨ費ȴһʱ䣬Ħɨͷȴ3룬 зɨͷȴ10
	 * 
	 * @param nCode
	 *            ɨͷʾзɨͷ0x55,Ħɨͷ0x00
	 * @return ɨ赽룬ûɨΪַ
	 */
	static public native String ReadSCA(int nCode);

	/**
	 * ͬɨһά/ά룬ɨ費ȴһʱ䣬Ħɨͷȴ3룬 зɨͷȴ10
	 * 
	 * @param nCommand
	 *            :ɨͷʾзɨͷ0x55,Ħɨͷ0x00
	 * @param nCode
	 *            :ı뷽ʽGB2312Ϊ1,UTFΪ0
	 * @return ɨ赽룬ûɨΪַ
	 */
	static public native String ReadSCAEx(int nCommand, int nCode);

	/**
	 * ͬɨһά/ά룬ɨ費ȴһʱ䣬Ħɨͷȴ3룬 зɨͷȴ10
	 * 
	 * @param nCommand
	 *            :ɨͷʾзɨͷ0x55,Ħɨͷ0x00
	 * @param buf
	 *            :ݣ뱾ʽתַ
	 * @return ɨ赽룬ûɨΪַ
	 */
	static public native int ReadDataSCA(int nCommand, byte[] buf);

	/**
	 * ͬɨһά/ά룬ɨ費ȴһʱ䣬Ħɨͷȴ3룬 зɨͷȴ10
	 * 
	 * @param nCommand
	 *            :ɨͷʾзɨͷ0x55,Ħɨͷ0x00
	 * @return :ɨ赽
	 */
	static public native byte[] ReadData(int nCommand);

	/**
	 * ʼ豸
	 * 
	 * @return ɹ0
	 */
	static public native int InitSCA();

	/**
	 * 첽ɨ裬øúᴴһɨ߳ȥɨ裬 ɨ赽ɨ賬ʱͨhandleϢߣ
	 * ʹ첽ɨĻĽմﴴhandle, handlem_handlerɨ赽뷢Message
	 * BARCODE_READ ʱMessage BARCODE_NOREAD
	 */
	static public void Read() {
		if (m_bASYC) {
			return;
		} else {
			// m_nCommand=nCode;
			StartASYC();
		}
	}

	/**
	 * ɨ߳
	 */
	static void StartASYC() {
		m_bASYC = true;
		Thread thread = new Thread(new Runnable() {
			public void run() {

				if (m_handler != null) {

					String str = ReadSCAAuto();
					Message msg = new Message();
					msg.what = str.length() > 0 ? BARCODE_READ : BARCODE_NOREAD;
					msg.obj = str;

					m_handler.sendMessage(msg);

				}

				m_bASYC = false;
			}
		});
		thread.start();
	}

	/**
	 * Ϣ԰StringϢʽ͸ϵͳ
	 * 
	 * @param str
	 *            Ҫ͵ַ
	 */
	static public void SendString(String str) {
		try {
			Runtime.getRuntime().exec("input keyevent 66");
			Runtime.getRuntime().exec("input text " + str);

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			Log.i("run", e.toString());
		}
	}

	static private void showToast(String str) {
		Toast.makeText(null, str, Toast.LENGTH_SHORT).show();
	}

	static {

		System.loadLibrary("hardware-print");
	}

}
